(*
  
  Fill Poly    unit v2.1
  
  (c)1994   Rsc Research

  Write me at:     or on Compuserve
       
  Cdric Rime           100340,2736
  Rte Palezieux
  1615 Bossonnens
  Switzerland


  This program is entered as Shareware.

  Feel free to incorporate the code into your own programs.
  If you have any suggestion or any tips, contact me !

*)

{$F-}{$N+}{$E+}{$D-}{$L-}{$Y-}
UNIT DrawPoly;
INTERFACE

USES crt;

TYPE PT=RECORD x,y:LongInt;END;         (*Point Type X,Y*)
     tTRI =ARRAY[1..3] OF pt;


TYPE VirtualXY=ARRAY[0..199,0..319] OF BYTE;    (*Virtual Display*)
     Virtual = Array [1..64000] of byte;  { The size of our Virtual Screen }
     VirtPtr = ^Virtual;                  { Pointer to the virtual screen }

VAR Virscr : VirtPtr;                     { Our first Virtual screen }
    Vaddr  : word;                        { The segment of our virtual screen}
    Where  : word;

PROCEDURE Point(x,y:longint;co:BYTE);   (*Draw a point*)
PROCEDURE Quad(p:ARRAY OF pt;co:BYTE);  (*Draw 4 sides polygon*)
PROCEDURE Tri(P:ARRAY OF pt;co:BYTE);   (*Draw 3 sides    "*)
PROCEDURE Triangle(x1,y1,x2,y2,x3,y3:longint;co:BYTE);

PROCEDURE vscls(col:byte);              (*Clear display*)
PROCEDURE vsShow;                       (*Show  display*)
PROCEDURE vsInit;                       (*Init Display*)
PROCEDURE vsDone;                       (*Restore Display*)
PROCEDURE SetRGB(co,r,g,b:BYTE);
PROCEDURE GetRGB(co:byte;var r,g,b:BYTE);


PROCEDURE TriFirst (x1,y1,x2,y2,x3,y3:longint;co:BYTE); (*dessine pixel pairs*)
PROCEDURE TriSecond(x1,y1,x2,y2,x3,y3:longint;co:BYTE); (*dessine pixel impairs*)

IMPLEMENTATION


PROCEDURE SetRGB(co,r,g,b:BYTE);
BEGIN
Port[$3C8] := Co;
Port[$3C9] := R;
Port[$3C9] := G;
Port[$3C9] := B;
END;

PROCEDURE GetRGB(co:byte;var r,g,b:BYTE);
BEGIN
Port[$3C7] := Co;
R:=Port[$3C9] ;
G:=Port[$3C9];
B:=Port[$3C9];
END;


PROCEDURE vsInit;
VAR q:BYTE;
BEGIN
GetMem(virscr,64002);
IF virscr=NIL THEN BEGIN WriteLn;WriteLn('Not enough memory');HALT;END;
where := seg (virscr^);
asm
mov ax,$0013
Int $10
END;
FOR q:=1 TO 255 DO setrgb(q,q SHR 2,0,q DIV 10);
END;

PROCEDURE vsDone;
BEGIN
TextMode(lastmode);
FreeMem(virscr,64002);
END;


PROCEDURE vscls(col:byte);
   { This clears the screen to the specified color }
BEGIN
     asm
        push    es
        mov     cx, 32000;
        mov     es,[where]
        xor     di,di
        mov     al,[col]
        mov     ah,al
        rep     stosw
        pop     es
     End;
END;

PROCEDURE vsShow;
BEGIN
  asm
    push    ds
    mov     ax, $a000
    mov     es, ax
    mov     ax, [Where]
    mov     ds, ax
    xor     si, si
    xor     di, di
    mov     cx, 32000
    rep     movsw
    pop     ds
  end;
END;

PROCEDURE Point(x,y:longint;co:BYTE);
BEGIN
IF (x<=319) AND (x>=0) AND (y<=199) AND (y>=0) THEN
   virtualxy(virscr^)[y,x]:=co;
END;


PROCEDURE Tri(P:ARRAY OF pt;co:BYTE);

PROCEDURE Hline(s1,s2:integer;y:integer;co:BYTE);assembler;
  { This draws a horizontal line from x1 to x2 on line y in color col }
asm
  mov   ax,where
  mov   es,ax
  mov   ax,y
  mov   di,ax
  shl   ax,8
  shl   di,6
  add   di,ax
  add   di,s1

  mov   al,co
  mov   ah,al
  mov   cx,s2
  sub   cx,s1
  inc   cx
  shr   cx,1
  jnc   @start
  stosb
@Start :
  rep   stosw
end;

var
  x1,y1,x2,y2,x3,y3,x4,y4:longint;
  x:longint;
  mny,mxy:longint;
  mnx,mxx,yc:longint;
  mul1,div1,
  mul2,div2,
  mul3,div3,
  mul4,div4:longint;

begin
x1:=p[0].x;y1:=p[0].y;
x2:=p[1].x;y2:=p[1].y;
x3:=p[2].x;y3:=p[2].y;
x4:=p[0].x;y4:=p[0].y;

  mny:=y1; mxy:=y1;
  if y2<mny then mny:=y2;
  if y2>mxy then mxy:=y2;
  if y3<mny then mny:=y3;
  if y3>mxy then mxy:=y3;    { Choose the min y mny and max y mxy }
  if y4<mny then mny:=y4;
  if y4>mxy then mxy:=y4;

  if mny<0 then mny:=0;
  if mxy>199 then mxy:=199;
  if mny>199 then exit;
  if mxy<0 then exit;        { Verticle range checking }

  mul1:=x1-x4; div1:=y1-y4;
  mul2:=x2-x1; div2:=y2-y1;
  mul3:=x3-x2; div3:=y3-y2;
  mul4:=x4-x3; div4:=y4-y3;  { Constansts needed for intersection calc }

  for yc:=mny to mxy do
    begin
      mnx:=320;
      mxx:=-1;
      if (y4>=yc) or (y1>=yc) then
        if (y4<=yc) or (y1<=yc) then   { Check that yc is between y1 and y4 }
          if not(y4=y1) then
            begin
              x:=(yc-y4)*mul1 div div1+x4; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y1>=yc) or (y2>=yc) then
        if (y1<=yc) or (y2<=yc) then   { Check that yc is between y1 and y2 }
          if not(y1=y2) then
            begin
              x:=(yc-y1)*mul2 div div2+x1; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y2>=yc) or (y3>=yc) then
        if (y2<=yc) or (y3<=yc) then   { Check that yc is between y2 and y3 }
          if not(y2=y3) then
            begin
              x:=(yc-y2)*mul3 div div3+x2; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y3>=yc) or (y4>=yc) then
        if (y3<=yc) or (y4<=yc) then   { Check that yc is between y3 and y4 }
          if not(y3=y4) then
            begin
              x:=(yc-y3)*mul4 div div4+x3; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if mnx<0 then
        mnx:=0;
      if mxx>319 then
        mxx:=319;          { Range checking on horizontal line }
      if mnx<=mxx then
        hline (mnx,mxx,yc,co);   { Draw the horizontal line }
    end;
  end;




(*#############################################################
###############################################################
###############################################################
#############################################################*)


PROCEDURE Quad(p:ARRAY OF pt;co:BYTE);

PROCEDURE Hline(s1,s2:integer;y:integer;co:BYTE);assembler;
  { This draws a horizontal line from x1 to x2 on line y in color col }
asm
  mov   ax,where
  mov   es,ax
  mov   ax,y
  mov   di,ax
  shl   ax,8
  shl   di,6
  add   di,ax
  add   di,s1

  mov   al,co
  mov   ah,al
  mov   cx,s2
  sub   cx,s1
  inc   cx
  shr   cx,1
  jnc   @start
  stosb
@Start :
  rep   stosw
end;

var
  x1,y1,x2,y2,x3,y3,x4,y4:longint;
  x:longint;
  mny,mxy:longint;
  mnx,mxx,yc:longint;
  mul1,div1,
  mul2,div2,
  mul3,div3,
  mul4,div4:longint;

begin
x1:=p[0].x;y1:=p[0].y;
x2:=p[1].x;y2:=p[1].y;
x3:=p[2].x;y3:=p[2].y;
x4:=p[3].x;y4:=p[3].y;

  mny:=y1; mxy:=y1;
  if y2<mny then mny:=y2;
  if y2>mxy then mxy:=y2;
  if y3<mny then mny:=y3;
  if y3>mxy then mxy:=y3;    { Choose the min y mny and max y mxy }
  if y4<mny then mny:=y4;
  if y4>mxy then mxy:=y4;

  if mny<0 then mny:=0;
  if mxy>199 then mxy:=199;
  if mny>199 then exit;
  if mxy<0 then exit;        { Verticle range checking }

  mul1:=x1-x4; div1:=y1-y4;
  mul2:=x2-x1; div2:=y2-y1;
  mul3:=x3-x2; div3:=y3-y2;
  mul4:=x4-x3; div4:=y4-y3;  { Constansts needed for intersection calc }

  for yc:=mny to mxy do
    begin
      mnx:=320;
      mxx:=-1;
      if (y4>=yc) or (y1>=yc) then
        if (y4<=yc) or (y1<=yc) then   { Check that yc is between y1 and y4 }
          if not(y4=y1) then
            begin
              x:=(yc-y4)*mul1 div div1+x4; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y1>=yc) or (y2>=yc) then
        if (y1<=yc) or (y2<=yc) then   { Check that yc is between y1 and y2 }
          if not(y1=y2) then
            begin
              x:=(yc-y1)*mul2 div div2+x1; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y2>=yc) or (y3>=yc) then
        if (y2<=yc) or (y3<=yc) then   { Check that yc is between y2 and y3 }
          if not(y2=y3) then
            begin
              x:=(yc-y2)*mul3 div div3+x2; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y3>=yc) or (y4>=yc) then
        if (y3<=yc) or (y4<=yc) then   { Check that yc is between y3 and y4 }
          if not(y3=y4) then
            begin
              x:=(yc-y3)*mul4 div div4+x3; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if mnx<0 then
        mnx:=0;
      if mxx>319 then
        mxx:=319;          { Range checking on horizontal line }
      if mnx<=mxx then
        hline (mnx,mxx,yc,co);   { Draw the horizontal line }
    end;
END;

(*#############################################################
###############################################################
###############################################################
#############################################################*)


PROCEDURE Triangle(x1,y1,x2,y2,x3,y3:longint;co:BYTE);

PROCEDURE Hline(s1,s2:integer;y:integer;co:BYTE);assembler;
  { This draws a horizontal line from x1 to x2 on line y in color col }
asm
  mov   ax,where
  mov   es,ax
  mov   ax,y
  mov   di,ax
  shl   ax,8
  shl   di,6
  add   di,ax
  add   di,s1

  mov   al,co
  mov   ah,al
  mov   cx,s2
  sub   cx,s1
  inc   cx
  shr   cx,1
  jnc   @start
  stosb
@Start :
  rep   stosw
end;

var
  x4,y4:longint;
  x:longint;
  mny,mxy:longint;
  mnx,mxx,yc:longint;
  mul1,div1,
  mul2,div2,
  mul3,div3,
  mul4,div4:longint;

begin
x4:=x1;y4:=y1;

  mny:=y1; mxy:=y1;
  if y2<mny then mny:=y2;
  if y2>mxy then mxy:=y2;
  if y3<mny then mny:=y3;
  if y3>mxy then mxy:=y3;    { Choose the min y mny and max y mxy }
  if y4<mny then mny:=y4;
  if y4>mxy then mxy:=y4;

  if mny<0 then mny:=0;
  if mxy>199 then mxy:=199;
  if mny>199 then exit;
  if mxy<0 then exit;        { Verticle range checking }

  mul1:=x1-x4; div1:=y1-y4;
  mul2:=x2-x1; div2:=y2-y1;
  mul3:=x3-x2; div3:=y3-y2;
  mul4:=x4-x3; div4:=y4-y3;  { Constansts needed for intersection calc }

  for yc:=mny to mxy do
    begin
      mnx:=320;
      mxx:=-1;
      if (y4>=yc) or (y1>=yc) then
        if (y4<=yc) or (y1<=yc) then   { Check that yc is between y1 and y4 }
          if not(y4=y1) then
            begin
              x:=(yc-y4)*mul1 div div1+x4; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y1>=yc) or (y2>=yc) then
        if (y1<=yc) or (y2<=yc) then   { Check that yc is between y1 and y2 }
          if not(y1=y2) then
            begin
              x:=(yc-y1)*mul2 div div2+x1; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y2>=yc) or (y3>=yc) then
        if (y2<=yc) or (y3<=yc) then   { Check that yc is between y2 and y3 }
          if not(y2=y3) then
            begin
              x:=(yc-y2)*mul3 div div3+x2; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y3>=yc) or (y4>=yc) then
        if (y3<=yc) or (y4<=yc) then   { Check that yc is between y3 and y4 }
          if not(y3=y4) then
            begin
              x:=(yc-y3)*mul4 div div4+x3; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if mnx<0 then
        mnx:=0;
      if mxx>319 then
        mxx:=319;          { Range checking on horizontal line }
      if mnx<=mxx then
        hline (mnx,mxx,yc,co);   { Draw the horizontal line }
    end;
  end;



PROCEDURE TriFirst(x1,y1,x2,y2,x3,y3:longint;co:BYTE);

PROCEDURE Hline(s1,s2:integer;y:integer;co:BYTE);
var q:integer;
begin
if (y div 2)*2=y then
    begin
    if (s1 div 2)*2<>s1 then inc(s1);
    end
    else
    if (s1 div 2)*2=s1 then inc(s1);
for q:=0 to ((s2-s1+1) div 2) do virtualxy(virscr^)[y,s1+q*2]:=co;
end;

var
  x4,y4:longint;
  x:longint;
  mny,mxy:longint;
  mnx,mxx,yc:longint;
  mul1,div1,
  mul2,div2,
  mul3,div3,
  mul4,div4:longint;

begin
x4:=x1;y4:=y1;

  mny:=y1; mxy:=y1;
  if y2<mny then mny:=y2;
  if y2>mxy then mxy:=y2;
  if y3<mny then mny:=y3;
  if y3>mxy then mxy:=y3;    { Choose the min y mny and max y mxy }
  if y4<mny then mny:=y4;
  if y4>mxy then mxy:=y4;

  if mny<0 then mny:=0;
  if mxy>199 then mxy:=199;
  if mny>199 then exit;
  if mxy<0 then exit;        { Verticle range checking }

  mul1:=x1-x4; div1:=y1-y4;
  mul2:=x2-x1; div2:=y2-y1;
  mul3:=x3-x2; div3:=y3-y2;
  mul4:=x4-x3; div4:=y4-y3;  { Constansts needed for intersection calc }

  for yc:=mny to mxy do
    begin
      mnx:=320;
      mxx:=-1;
      if (y4>=yc) or (y1>=yc) then
        if (y4<=yc) or (y1<=yc) then   { Check that yc is between y1 and y4 }
          if not(y4=y1) then
            begin
              x:=(yc-y4)*mul1 div div1+x4; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y1>=yc) or (y2>=yc) then
        if (y1<=yc) or (y2<=yc) then   { Check that yc is between y1 and y2 }
          if not(y1=y2) then
            begin
              x:=(yc-y1)*mul2 div div2+x1; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y2>=yc) or (y3>=yc) then
        if (y2<=yc) or (y3<=yc) then   { Check that yc is between y2 and y3 }
          if not(y2=y3) then
            begin
              x:=(yc-y2)*mul3 div div3+x2; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y3>=yc) or (y4>=yc) then
        if (y3<=yc) or (y4<=yc) then   { Check that yc is between y3 and y4 }
          if not(y3=y4) then
            begin
              x:=(yc-y3)*mul4 div div4+x3; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if mnx<0 then
        mnx:=0;
      if mxx>319 then
        mxx:=319;          { Range checking on horizontal line }
      if mnx<=mxx then
        hline (mnx,mxx,yc,co);   { Draw the horizontal line }
    end;
  end;

PROCEDURE TriSecond(x1,y1,x2,y2,x3,y3:longint;co:BYTE);

PROCEDURE Hline(s1,s2:integer;y:integer;co:BYTE);
var q:integer;
begin
if (y div 2)*2=y then
    begin
    if (s1 div 2)*2<>s1 then inc(s1);
    end
    else
    if (s1 div 2)*2=s1 then inc(s1);
for q:=0 to ((s2-s1+1) div 2) do virtualxy(virscr^)[y,s1+q*2+1]:=co;
end;

var
  x4,y4:longint;
  x:longint;
  mny,mxy:longint;
  mnx,mxx,yc:longint;
  mul1,div1,
  mul2,div2,
  mul3,div3,
  mul4,div4:longint;

begin
x4:=x1;y4:=y1;

  mny:=y1; mxy:=y1;
  if y2<mny then mny:=y2;
  if y2>mxy then mxy:=y2;
  if y3<mny then mny:=y3;
  if y3>mxy then mxy:=y3;    { Choose the min y mny and max y mxy }
  if y4<mny then mny:=y4;
  if y4>mxy then mxy:=y4;

  if mny<0 then mny:=0;
  if mxy>199 then mxy:=199;
  if mny>199 then exit;
  if mxy<0 then exit;        { Verticle range checking }

  mul1:=x1-x4; div1:=y1-y4;
  mul2:=x2-x1; div2:=y2-y1;
  mul3:=x3-x2; div3:=y3-y2;
  mul4:=x4-x3; div4:=y4-y3;  { Constansts needed for intersection calc }

  for yc:=mny to mxy do
    begin
      mnx:=320;
      mxx:=-1;
      if (y4>=yc) or (y1>=yc) then
        if (y4<=yc) or (y1<=yc) then   { Check that yc is between y1 and y4 }
          if not(y4=y1) then
            begin
              x:=(yc-y4)*mul1 div div1+x4; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y1>=yc) or (y2>=yc) then
        if (y1<=yc) or (y2<=yc) then   { Check that yc is between y1 and y2 }
          if not(y1=y2) then
            begin
              x:=(yc-y1)*mul2 div div2+x1; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y2>=yc) or (y3>=yc) then
        if (y2<=yc) or (y3<=yc) then   { Check that yc is between y2 and y3 }
          if not(y2=y3) then
            begin
              x:=(yc-y2)*mul3 div div3+x2; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if (y3>=yc) or (y4>=yc) then
        if (y3<=yc) or (y4<=yc) then   { Check that yc is between y3 and y4 }
          if not(y3=y4) then
            begin
              x:=(yc-y3)*mul4 div div4+x3; { Point of intersection on x axis }
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;       { Set point as start or end of horiz line }
            end;
      if mnx<0 then
        mnx:=0;
      if mxx>319 then
        mxx:=319;          { Range checking on horizontal line }
      if mnx<=mxx then
        hline (mnx,mxx,yc,co);   { Draw the horizontal line }
    end;
  end;


BEGIN
END.
