(*
    StereoScopic View:
  Quick Shade  unit v1.1  
    use green&red glasses to get deep on your 3D.
  (c)1994   Rsc Research

  Write me at:     or on Compuserve
       
  Cdric Rime           100340,2736
  Dixence 21
  1950 Sion
  Switzerland


  This program is entered as Shareware.
  If you find it useful, a small donation would be appreciated.(then i can take some English lessons!!!)

  Feel free to incorporate the code into your own programs.

*)


{$F-}
{$N+}
{$D-}
{$L-}
{$Y-}


UNIT Pshade;
INTERFACE


{$define pointperface=3}
USES drawpoly,crt,tools;

type real=single;

TYPE points=RECORD
       x,y,z:real;
       END;
     patchs=RECORD
       s1,s2,s3:WORD;
       col:BYTE;
       END;


CONST MaxP=3200;                 (*Max points in world*)

var SeparationStereo:integer;    (*Angle ALPHA/2 between two eyes*)

VAR centerX,centerY,centerZ:real;(*recenter drawing*)

TYPE tpnt=       ARRAY[1..MaxP] OF points;
     tpat=       ARRAY[1..MaxP] OF patchs;
     tdwg=       ARRAY[1..MaxP] OF pt;
     tzbuffering=ARRAY[1..MaxP] OF real;
     tsort=      ARRAY[1..MaxP] OF WORD;
     ppnt=^tpnt;
     ppat=^tpat;
     pdwg=^tdwg;
     pzbuffering=^tzbuffering;
     psort=^tsort;

var CalcAX,CalcAY,CalcAZ,CalcDIST:real;

VAR pnt:ppnt;
    pat:ppat;
    dwg:pdwg;
    zbuffering:pzbuffering;
    sort:psort;

    pacount:WORD;                (*Patch in drawing*)
    pocount:WORD;                (*Points in drawing*)
    midx,midy:INTEGER;           (*Screen Center coord. = Drawing center*)

    Light1,Light2:INTEGER;       (*2 points for light direction*)
    LightPat:INTEGER;            (*1 patch for light drawing*)
    LightRadius:real;            (*Length for Light drawing*)

    LightColor:BYTE;             (*What's color*)
    LightFactor:real;            (*Light Factory*)
    LightAmbient:BYTE;           (*Light Ambient*)

    FrontClip:real;              (*Minimal value for front clipping*)

PROCEDURE tshadeINIT;
PROCEDURE tshadeDONE;

PROCEDURE AddLight;              (*Show LightPosition*)
PROCEDURE redraw(col:byte);      (*Redraw Picture, use double buffering*)
PROCEDURE Clear;                 (*Clean drawing*)
FUNCTION  AddPoint(x,y,z:real):INTEGER;       (*Add a point in drawing*)
PROCEDURE AddPatch(s1,s2,s3:INTEGER;co:BYTE); (*Add a patch on 3 points*)
PROCEDURE Add4Patch(s1,s2,s3,s4:INTEGER;co:BYTE);
PROCEDURE AddBOX(x1,y1,z1,x2,y2,z2:real;co:byte);(*draw a BOX*)

PROCEDURE move_center(orgx,orgy,orgz:real);   (*Move Drawing*)
PROCEDURE gravity(VAR xx,yy,zz:real);         (*Calc gravity center*)
PROCEDURE worldscale(sx,sy,sz:real);

PROCEDURE calc(ax,ay,az,dist:real);           (*Rotate drawing on AX&AY angle, AZ=focus DIST=distance*)
PROCEDURE xshade(sun_a,sun_b,sun_c:real);     (*Quick Shading on XYZ axis*)
PROCEDURE shadepalette(faca,facb,facc:real;baseR,BaseG,BaseB:BYTE);
                                              (*Smooth palette, Factor for R,G,B, Base for R,G,B*)
PROCEDURE LoadMesh(nom:STRING;scalex,scaley,scalez:real;col:BYTE);
                                              (*Import Ascii meshes from 3D Studio or ...*)
PROCEDURE Pop;PROCEDURE push;                 (*Used into LoadMesh*)

PROCEDURE CAMERA(x1,y1,z1,x2,y2,z2:real);


procedure LOAD3D(name:string);
procedure SAVE3D(name:string);

IMPLEMENTATION

PROCEDURE xcalc(ax,ay,az,dist:real);forward;

PROCEDURE ERROR(S:STRING); (*FATAL ERROR HANDLER*)
BEGIN
TEXTMODE(LASTMODE);
WRITELN('FATAL ERROR:');
WRITELN('');
WRITELN(S);
HALT;
END;

(*########################################################################*)
PROCEDURE tshadeINIT;
var q:longint;
BEGIN
q:=MaxP*sizeof(points);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (1)');
getmem(pnt,q);
if pnt=nil then error('TSHADE : memory allocation error in tshadeINIT (1a)');
q:=MaxP*sizeof(patchs);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (2)');
getmem(pat,q);
if pat=nil then error('TSHADE : memory allocation error in tshadeINIT (2a)');
q:=MaxP*sizeof(pt);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (3)');
getmem(dwg,q);
if dwg=nil then error('TSHADE : memory allocation error in tshadeINIT (3a)');
q:=MaxP*sizeof(real);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (4)');
getmem(zbuffering,q);
if zbuffering=nil then error('TSHADE : memory allocation error in tshadeINIT (4a)');
q:=MaxP*sizeof(word);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (5)');
getmem(sort,q);
if sort=nil then error('TSHADE : memory allocation error in tshadeINIT (5a)');
END;

(*########################################################################*)
PROCEDURE tshadeDONE;
var q:longint;
BEGIN
q:=MaxP*sizeof(points);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (1)');
freemem(pnt,q);
q:=MaxP*sizeof(patchs);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (2)');
freemem(pat,q);
q:=MaxP*sizeof(pt);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (3)');
freemem(dwg,q);
q:=MaxP*sizeof(real);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (4)');
freemem(zbuffering,q);
q:=MaxP*sizeof(word);
if q>65500 then error('TSHADE : internal error code in tshadeINIT (5)');
freemem(sort,q);
END;


function Rac2(v:real):real;
begin
if v=0 then rac2:=0.00001 else rac2:=sqrt(v);
end;

(*########################################################################*)

PROCEDURE worldscale(sx,sy,sz:real);
VAR Q:INTEGER;
BEGIN
FOR Q:=1 TO POCOUNT DO PNT^[Q].X:=PNT^[Q].X*SX;
FOR Q:=1 TO POCOUNT DO PNT^[Q].Y:=PNT^[Q].Y*SY;
FOR Q:=1 TO POCOUNT DO PNT^[Q].Z:=PNT^[Q].Z*SZ;
END;

(*########################################################################*)

PROCEDURE gravity(VAR xx,yy,zz:real);
VAR q:INTEGER;
BEGIN
xx:=0;yy:=0;zz:=0;
FOR q:=1 TO pocount DO BEGIN xx:=xx+pnt^[q].x;yy:=yy+pnt^[q].y;zz:=zz+pnt^[q].z;END;
xx:=xx/pocount;yy:=yy/pocount;zz:=zz/pocount;
END;

(*########################################################################*)

FUNCTION ztest(r:real):real; (*If R=0 then return=0.0001*)
BEGIN
IF r=0  THEN ztest:=0.0001 ELSE ztest:=r;
END;


(*########################################################################*)

PROCEDURE AddLight;
BEGIN
Light1:=addpoint(0,0,0);
Light2:=addpoint(0,0,0);
Addpatch(light1,light2,light2,LightColor);
LightPat:=pacount;
END;

(*########################################################################*)

PROCEDURE redraw(col:byte);
VAR q2,q1:INTEGER;
    fa:ARRAY[1..3] OF pt;
    stereo:real;
BEGIN
stereo:=separationstereo*0.25;
vscls(col);
dec(Midx,5);
xcalc(calcAX-stereo,calcAY+stereo,calcAZ,calcDIST);
FOR q2:=1 TO pacount DO (*red design*)
          WITH dwg^[q1] DO
          trifirst(dwg^[pat^[sort^[q2]].s1].x,dwg^[pat^[sort^[q2]].s1].y,
                   dwg^[pat^[sort^[q2]].s2].x,dwg^[pat^[sort^[q2]].s2].y,
                   dwg^[pat^[sort^[q2]].s3].x,dwg^[pat^[sort^[q2]].s3].y,
                   pat^[sort^[q2]].col);
inc(Midx,5);
xcalc(calcAX+stereo,calcAY-stereo,calcAZ,calcDIST);
FOR q2:=1 TO pacount DO (*green design*)
          WITH dwg^[q1] DO
          trisecond(dwg^[pat^[sort^[q2]].s1].x,dwg^[pat^[sort^[q2]].s1].y,
                   dwg^[pat^[sort^[q2]].s2].x,dwg^[pat^[sort^[q2]].s2].y,
                   dwg^[pat^[sort^[q2]].s3].x,dwg^[pat^[sort^[q2]].s3].y,
                   pat^[sort^[q2]].col+128);
vsshow;
END;

(*########################################################################*)


PROCEDURE move_center(orgx,orgy,orgz:real);
VAR q:INTEGER;
BEGIN
FOR q:=1 TO pocount DO pnt^[q].x:=pnt^[q].x-orgx;
FOR q:=1 TO pocount DO pnt^[q].y:=pnt^[q].y-orgy;
FOR q:=1 TO pocount DO pnt^[q].z:=pnt^[q].z-orgz;
END;

(*########################################################################*)

PROCEDURE SetRGBPalette(co,r,g,b:BYTE);
BEGIN
Port[$3C8] := Co;
Port[$3C9] := R;
Port[$3C9] := G;
Port[$3C9] := B;
END;

(*########################################################################*)

PROCEDURE shadepalette(faca,facb,facc:real;baseR,BaseG,BaseB:BYTE);
VAR q:INTEGER;
BEGIN
IF faca=0 THEN faca:=0.00001;
IF facb=0 THEN facb:=0.00001;
faca:=faca/100*(63-baseR)/127;
facb:=facb/100*(63-baseG)/127;
FOR q:=1 TO 127 DO setrgbpalette(q,trunc(faca*q)+baseR,0,0);
FOR q:=1 TO 127 DO setrgbpalette(q+128,0,trunc(facb*q)+baseG,0);
END;

(*########################################################################*)

PROCEDURE xshade(sun_a,sun_b,sun_c:real);
VAR e,q,w:INTEGER;
    nor,cpx,cpy,cpz, cosa, ang1,ang2:real;
    xu,yu,zu,xv,yv,zv,xn,y0n,zn,v1,v2,v3,v4,v5,xw,yw,zw:real;
BEGIN
nor:=rac2(sqr(sun_a)+sqr(sun_b)+sqr(sun_c));
sun_a:=sun_a/nor;sun_b:=sun_b/nor;sun_c:=sun_c/nor; (*vecteur normalise*)

FOR q:=1 TO pacount DO WITH pat^[q] DO BEGIN

    xu := pnt^[s2].x -pnt^[s1].x ;
    yu := pnt^[s2].y -pnt^[s1].y ;
    zu := pnt^[s2].z -pnt^[s1].z ; (* vector 1 a 2 *)
    xv := pnt^[s3].x -pnt^[s1].x ;
    yv := pnt^[s3].y -pnt^[s1].y ;
    zv := pnt^[s3].z -pnt^[s1].z ; (* vector 1 a 3 *)

    (*cross product v12 and v13*)

                         (*cpx:=ay*bz-az*by;*)
    cpx:=(yu*zv)-(zu*yv);
                         (*cpy:=az*bx-ax*bz;*)
    cpy:=(zu*xv)-(xu*zv);
                         (*cpz:=ax*by-ay*bx;*)
    cpz:=(xu*yv)-(yu*xv);


    (*delta angle (radian) between CP and SUN*)
    cosa:= ((cpx*sun_a)+(cpy*sun_b)+(cpz*sun_c))
            /
            (rac2(sqr(cpx)+sqr(cpy)+sqr(cpz))
            *
             rac2(sqr(sun_a)+sqr(sun_b)+sqr(sun_c)));

    v4:=cosa*127/LightFactor+LightAmbient;
    if v4<1 then v4:=1;
    if v4>127 then v4:=127;
    col:=Trunc(v4);
    END;
IF light1<>-1 THEN
   BEGIN (*If ADDLIGHT was used*)
   pnt^[light1].x:=ztest(sun_A*LightRadius);
   pnt^[light1].y:=ztest(sun_B*LightRadius);
   pnt^[light1].z:=ztest(sun_C*LightRadius);
   pnt^[light2].x:=ztest(sun_A*LightRadius/2);
   pnt^[light2].y:=ztest(sun_B*LightRadius/2);
   pnt^[light2].z:=ztest(sun_C*LightRadius/2);
   pat^[LightPat].col:=LightColor;
   END;

END;

(*########################################################################*)

procedure calc(ax,ay,az,dist:real);
begin
calcAX:=ax;
calcAY:=ay;
calcAZ:=az;
calcDIST:=dist;
end;

PROCEDURE xcalc(ax,ay,az,dist:real);
VAR q,w:INTEGER;
    aux1,aux2,aux3,aux4,aux5,aux6,aux7,aux8:real;
    x_obs,y_obs,z_obs:real;
    sum:ARRAY[1..MaxP] OF real;
    sum_old:real;
    e:WORD;
PROCEDURE init_projection(the,phi:real);
VAR th,ph:real;
BEGIN
th:=the*0.017454;ph:=phi*0.017454;
aux1:=Sin(th);aux2:=Sin(ph);aux3:=Cos(th);aux4:=Cos(ph);
aux5:=aux3*aux2;aux6:=aux1*aux2;aux7:=aux3*aux4;aux8:=aux1*aux4;
END;

PROCEDURE QuickSort;
VAR Lo,Hi:INTEGER;
    i, j : INTEGER;
    x,y:real;
    v:INTEGER;
 PROCEDURE qSort(l, r: INTEGER);
 BEGIN
   i := l; j := r; x := sum[(l+r) DIV 2];
   REPEAT
     WHILE sum[i] < x DO i := i + 1;
     WHILE x < sum[j] DO j := j - 1;
     IF i <= j THEN
     BEGIN
       y := sum[i]; sum[i]:= sum[j]; sum[j]:=y;
       v := sort^[i];sort^[i]:=sort^[j];sort^[j]:=v;
       i := i + 1; j := j - 1;
     END;
   UNTIL i > j;
   IF l < j THEN qSort(l, j);
   IF i < r THEN qSort(i, r);
 END;

 BEGIN {QuickSort};
   Lo:=1;Hi:=Pacount;
   qSort(Lo,Hi);
 END;


BEGIN
init_projection(ax,ay);
FOR q:=1 TO pocount DO BEGIN
{    x_obs:=centerx+(-pnt^[q].x*aux1+pnt^[q].y*aux3);               }
{    y_obs:=centery+(-pnt^[q].x*aux5-pnt^[q].y*aux6+pnt^[q].z*aux4);}
    zbuffering^[q]:=
           dist/
           (centerz+(-pnt^[q].x*aux7-pnt^[q].y*aux8-pnt^[q].z*aux2+az) );
    dwg^[q].x:=midx+trunc((centerx+(-pnt^[q].x*aux1+pnt^[q].y*aux3))
                          *zbuffering^[q]);
    dwg^[q].y:=midy+trunc((centery+(-pnt^[q].x*aux5-pnt^[q].y*aux6+pnt^[q].z*aux4))*zbuffering^[q]);
    END;

FOR q:=1 TO pacount DO sort^[q]:=q;
FOR q:=1 TO pacount DO
    WITH pat^[q] DO
    sum[q]:=zbuffering^[s1]+zbuffering^[s2]+zbuffering^[s3];
quicksort;
END;

(*########################################################################*)
PROCEDURE CAMERA(x1,y1,z1,x2,y2,z2:real);
var norm:real;
    focus:real;
    vx,vy,vz:real;
    ax,ay:real;
    sx,sy:real;
begin
norm:=  sqrt(sqr(x2-x1)+sqr(y2-y1)+sqr(z2-z1));
focus:= norm*2.5;

centerX:=x1;centerY:=y1;centerZ:=z1;
vx:=x2-x1;vy:=y2-y1;vz:=z2-z1;

ax:=(vx/vy)*45;
ay:=(vz/vx)*45;

calc(AX,AY,norm,focus);
end;

(*########################################################################*)

PROCEDURE Clear;
BEGIN
pocount:=0;
pacount:=0;
END;

(*########################################################################*)
VAR old:INTEGER;
FUNCTION  AddPoint(x,y,z:real):INTEGER;
BEGIN
IF pocount>=MaxP THEN EXIT;
INC(pocount);
IF x=0 THEN x:=0.0001;
IF y=0 THEN y:=0.0001;
IF z=0 THEN z:=0.0001;
(*writeln(pocount,'==>',pocount+old);readkey;*)
Pnt^[pocount].x:=x;
Pnt^[pocount].y:=y;
Pnt^[pocount].z:=z;
Addpoint:=pocount;
END;

(*########################################################################*)

PROCEDURE AddPatch(s1,s2,s3:INTEGER;co:BYTE);
BEGIN
(*writeln(s1,',',s2,',',s3,'==>',s1+old,',',s2+old,',',s3+old);readkey;*)
IF pacount>=MaxP THEN EXIT;
INC(pacount);
Pat^[pacount].s1:=s1+old;
Pat^[pacount].s2:=s2+old;
Pat^[pacount].s3:=s3+old;
Pat^[pacount].col:=co;
END;

PROCEDURE Add4Patch(s1,s2,s3,s4:INTEGER;co:BYTE);
BEGIN
(*writeln(s1,',',s2,',',s3,',',s4,'==>',s1+old,',',s2+old,',',s3+old,',',s4+old);readkey;*)
IF pacount>=MaxP THEN EXIT;
INC(pacount);
Pat^[pacount].s1:=s1+old;
Pat^[pacount].s2:=s2+old;
Pat^[pacount].s3:=s3+old;
Pat^[pacount].col:=co;
IF pacount>=MaxP THEN EXIT;
INC(pacount);
Pat^[pacount].s1:=s1+old;
Pat^[pacount].s2:=s3+old;
Pat^[pacount].s3:=s4+old;
Pat^[pacount].col:=co;
END;


(*########################################################################*)

PROCEDURE Push;
BEGIN
old:=Pocount;
END;
PROCEDURE Pop;
BEGIN
old:=0;
END;

(*########################################################################*)
(*With LOADMESH, you will load an ASCII mesh file, ge. 3d Studio,...*)
PROCEDURE LoadMesh(nom:STRING;scalex,scaley,scalez:real;col:BYTE);
VAR f:TEXT;
    x,y,z:real;
    p1,p2,p3,p4:INTEGER;
    a,s,lin:STRING;
    q:INTEGER;
    FUNCTION  GetWord2(st:STRING):STRING;
    VAR q,w:INTEGER;
        a:STRING;
    BEGIN
    IF Length(st)<2 THEN BEGIN GetWord2:='';EXIT;END;
    IF st[1]=' ' THEN
       BEGIN
       REPEAT
       Delete(st,1,1);
       UNTIL (st[1]<>' ') OR (Length(st)<1);
       END;
    a:='';
    REPEAT
     a:=a+st[1];
     Delete(st,1,1);
    UNTIL (st[1]=' ') OR (Length(st)<1);
    GetWord2:=a;
    END;

    FUNCTION  GetWord(var st:STRING):STRING;
    VAR q,w:INTEGER;
        a:STRING;
    BEGIN
    IF Length(st)<2 THEN BEGIN GetWord:='';EXIT;END;
    IF st[1]=' ' THEN
       BEGIN
       REPEAT
       Delete(st,1,1);
       UNTIL (st[1]<>' ') OR (Length(st)<1);
       END;
    a:='';
    REPEAT
     a:=a+st[1];
     Delete(st,1,1);
    UNTIL (st[1]=' ') OR (Length(st)<1);
    GetWord:=a;
    END;

VAR L:real;
    AA:LONGINT;
    FB:FILE;
BEGIN
directvideo:=false;
writeln('Loading : '+toupper(nom));
writeln('');
push;
Assign(Fb,nom);
reset(fb,1);
L:=FILESIZE(Fb);
if l=0 then l:=0 else l:=100 / l;
close(FB);

Assign(f,nom);
{$i-}
Reset(f);
aa:=0;

REPEAT
ReadLn(f,lin);lin:=toupper(lin);a:=lin;
INC(aa,LENGTH(LIN));
s:=getword(a);
IF s='NAMED' THEN begin push;gotoxy(1,wherey);writeln(getword2((copy(lin,pos(':',lin)+1,25))),' (',old,')');end;
IF s='VERTEX' THEN
              IF Copy(getword(a),1,4)<>'LIST' THEN
              BEGIN
              getword(a);
              Val(getword(a),x,q);
              getword(a);
              Val(getword(a),y,q);
              getword(a);
              Val(getword(a),z,q);
              addpoint(x*scalex,y*scaley,z*scalez);
              END;
IF s='FACE'   THEN
              IF Copy(getword(a),1,4)<>'LIST' THEN
              BEGIN
              s:=getword(a);
              p1:=1+ival(Copy(s+' ',3,Length(s)-2));
              s:=getword(a);
              p2:=1+ival(Copy(s+' ',3,Length(s)-2));
              s:=getword(a);
              p3:=1+ival(Copy(s+' ',3,Length(s)-2));
              Addpatch(p1,p2,p3,col);
              END;
(*writeln(pocount:4,pacount:4,lin);*)
if aa mod 10=0 then begin gotoxy(1,wherey);write(100-(l*aa):4:1,' %');end;
UNTIL Eof(f);
pop;
gotoxy(1,wherey);
Close(f);
writeln('Ready.');
END;

(*########################################################################*)
(*########################################################################*)
(*########################################################################*)
const copyright:string='(c)95-rsc research';
procedure SAVE3D(name:string);
var f:file;
begin
assign(f,name+'.3d');
rewrite(f,1);
blockwrite(f,copyright,sizeof(copyright));
blockwrite(f,pocount,sizeof(pocount));
blockwrite(f,pacount,sizeof(pacount));
blockwrite(f,pnt^,pocount*sizeof(points));
blockwrite(f,pat^,pacount*sizeof(patchs));
close(f);
end;
(*########################################################################*)
(*########################################################################*)
(*########################################################################*)
procedure LOAD3D(name:string);
var f:file;
    chk:string;
begin
assign(f,name+'.3d');
reset(f,1);
blockread(f,chk,sizeof(copyright));
if chk<>copyright then begin close(f);end;
blockread(f,pocount,sizeof(pocount));
blockread(f,pacount,sizeof(pacount));
blockread(f,pnt^,pocount*sizeof(points));
blockread(f,pat^,pacount*sizeof(patchs));
close(f);
end;


PROCEDURE AddBOX(x1,y1,z1,x2,y2,z2:real;co:byte);(*draw a BOX*)
var p1,p2,p3,p4,p5,p6,p7,p8:integer;
    q:real;
begin
if x2<x1 then begin q:=x1;x1:=x2;x2:=q;end;
if y2<y1 then begin q:=y1;y1:=y2;y2:=q;end;
if z2<z1 then begin q:=z1;z1:=z2;z2:=q;end;
 old:=0;
 p1:=addpoint(x1,y1,z1);         (*Build a six sided cube*)
 p2:=addpoint(x2,y1,z1);
 p3:=addpoint(x2,y2,z1);
 p4:=addpoint(x1,y2,z1);
 p5:=addpoint(x1,y1,z2);
 p6:=addpoint(x2,y1,z2);
 p7:=addpoint(x2,y2,z2);
 p8:=addpoint(x1,y2,z2);
 add4patch(p4,p3,p2,p1,0);
 add4patch(p5,p6,p7,p8,0);
 add4patch(p1,p2,p6,p5,0);
 add4patch(p2,p3,p7,p6,0);
 add4patch(p3,p4,p8,p7,0);
 add4patch(p4,p1,p5,p8,0);
end;

BEGIN
midx:=Round(160);
midy:=Round(100);
FrontClip:=-100;
Pocount:=0;Pacount:=0;old:=0;
LightFactor:=1;
Light1:=-1;
LightColor:=255;Lightpat:=-1;
LightAmbient:=0;
LightRadius:=50;
CenterX:=0;CenterY:=0;CenterZ:=0;
separationStereo:=1;
END.


