(*
  
  Tshade-Demo  unit v2.1
  
  (c)1995   Rsc Research

  Write me at:     or on Compuserve
       
  Cdric Rime           100340,2736
  Rte Palezieux
  1615 Bossonnens
  Switzerland


  This program is entered as Shareware.
  Feel free to incorporate the code into your own programs. (with my copyright)

  Any tips or suggestions would be appreciated !!!
*)

{$m 32768,0,600000}
{$F-} {$N+} {$E-} {$D-} {$L-} {$Y-}


(*USES crt,dos,DrawPoly,tshade,tools,math;*)  (*use this for flat-shading*)
USES crt,dos,DrawPoly,pshade,tools,math;      (*use this for stereo-glasses*)

type real=single;

VAR p1,p2,p3,p4,p5,p6,p7,p8:integer;
    qq,q,w,e,r,t:INTEGER;

    ax,ay:real;
    px,py,pz:real;(*gravity*)

    focus,distance:real;

    re:registers; (*80x86 registers*)
    s:ARRAY[0..199,0..319] OF BYTE ABSOLUTE $a000:0; (*pointer on MCGA $a000 segment*)
    out:BYTE;
    name:string;



PROCEDURE InitGraphics;
BEGIN
vsinit;
END;


BEGIN

if paramcount>0 then
 begin
  name:=paramstr(1);
  qq:=0;
  if not exist(name) then name:=name+'.msh';
  if not exist(name) then begin writeln('File not found');delay(500);qq:=1;end;
 end;
if paramcount=0 then
begin
 clrscr;
 writeln('TSHADE v4');
 writeln('RSC Research (c)95 - Cedric Rime, 1615 Bossonnens,Switzerland,CIS=100340,2736');
 writeln('');
 writeln;
 writeln('Type ENTER if you want to use a six sided cube or');
 writeln('Type the name of the mesh file (ASCII from 3DStudio)');
 writeln;
 write('File : ');readln(name);
 if name='' then qq:=1 else qq:=0;
 if qq=0 then
    begin
     if not exist(name) then name:=name+'.msh';
     if not exist(name) then begin writeln('File not found');delay(500);qq:=1;end;
    end;
end;

out:=0;                             (*If ESC key was pressed=>out:=1*)
tshadeinit;                         (*Allocate the memory for the 3Ddrawing*)
initgraphics;                       (*Init graphic mode 320x200x256*)
directvideo:=false;
setrgb(7,63,63,63);

clear;                              (*Clean the world*)
if qq=0 then
loadmesh(name,0.1,0.1,0.1,0) (*Load MeshFile: name,scaleXYZ,color*)
else
begin
 addbox(-10,-10,-10,+10,+10,+10,20);
 addbox(-20,-20,-10, -15,-15,+10,10);
 addbox(+15,-15,+10, +20,-20,-10,30);
 addbox(-20,+20,-10, -15,+15,+10,90);
 addbox(+15,+15,+10, +20,+20,-10,60);
end;

writeln('Build the palette');
shadepalette(75,75,75,15,15,15); (*Build a smooth palette r%,g%,b%,baseR,baseG,baseB*)

separationstereo:=1;
writeln('Get gravity center');
Gravity(px,py,pz);               (*Find gravity center*)

writeln('Recenter');
move_center(px,py,pz);           (*Center of the world=gravity*)

AddLight;                      (*show the Light Vector*)
ax:=1;ay:=6;
xshade(40,40,40);                (*Shade from 40X,20Y,40Z =>alpha=45',beta=45'*)
midx:=160;midy:=100;             (*Display center*)
distance:=60;focus:=179;         (*Distance & focus*)

REPEAT
(*camera(0,0,0,5,15,5); this function look at 0,0,0, from 5,15,5 (xyz)*)
calc(ax,ay,distance,focus);      (*Rotation around X and Y angle,distance & focus*)
redraw(0);                       (*Redraw with background color 0*)

repeat
re.ax:=3;Intr($33,re);           (*Get mouse position*)

FOR q:=-2 TO 2 DO
    s[re.dx+q,re.cx]:=255-s[re.dx+q,re.cx]; (*Draw a nice mouse cursor*)
FOR q:=-2 TO 2 DO
    s[re.dx,re.cx+q]:=255-s[re.dx,re.cx+q];
FOR q:=-2 TO 2 DO
    s[re.dx+q,re.cx]:=255-s[re.dx+q,re.cx]; (*Draw a nice mouse cursor*)
FOR q:=-2 TO 2 DO
    s[re.dx,re.cx+q]:=255-s[re.dx,re.cx+q];

until (re.bx<>0) or (keypressed);


IF re.bx=1 THEN                  (*Button 1=rotate*)
BEGIN
 ax:=re.cx*2;
 ay:=re.dx*2;
END;
IF re.bx=4 THEN                  (*Button 1&2=move center*)
BEGIN
 midx:=re.cx;
 midy:=re.dx;
END;
IF re.bx=3 THEN                  (*Button 3=Distance & Focus*)
BEGIN
 distance:=re.cx;
 focus:=   re.dx*10;
END;
IF re.bx=2 THEN                  (*Button 2=Shading*)
BEGIN
 xshade(sin(0.01745*(re.cx-midx)),cos(0.01745*(re.cx-midx)),sin(0.01745*(re.dx-midy)));
END;

IF KeyPressed THEN
   CASE UpCase(ReadKey) OF
    #27:out:=1;
    #00:case ord(readkey) of
         keyup   :ay:=ay-1;
         keydown :ay:=ay+1;
         keyleft :ax:=ax+1;
         keyright:ax:=ax-1;
         keyhome :ay:=ay-10;
         keyend  :ay:=ay+10;
         keydelete:ax:=ax+10;
         keypgdown:ax:=ax-10;
         end;
    '8':move_center(0,-1,0);
    '2':move_center(0,1,0);
    '7':move_center(-1,0,0);
    '1':move_center(1,0,0);
    '9':move_center(0,0,-1);
    '3':move_center(0,0,+1);
    '+':distance:=distance-1.01;
    '-':distance:=distance+1.01;
    '/':focus:=focus-1.01;
    '*':focus:=focus+1.01;
    ',':dec(separationstereo);
    '.':inc(separationstereo);
    END;
UNTIL out=1;
vsdone;                                 (*Restore Display & Release screenbuffer*)
tshadedone;                             (*Release all memory*)
END.



